using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Gpm2Utility {
  public partial class Form1 : Form {
    private Edy _edy;

    public Form1 () {
      InitializeComponent ();
    }

    private void _loadEdyUI_Click (object sender, EventArgs e) {
      OpenFileDialog ofd = new OpenFileDialog ();
      ofd.ReadOnlyChecked = true;
      ofd.DefaultExt = "cmp";
      ofd.AddExtension = false;
      ofd.Filter = "EDY files (*.edy;)|*.edy|All files (*.*)|*.*";
      //ofd.Title = "";

      DialogResult dg = ofd.ShowDialog ();
      if (dg == DialogResult.OK) {
        System.IO.FileInfo fileInfo = new System.IO.FileInfo (ofd.FileName);
        Text = "GPM2 - Utility - " + fileInfo.Name;
        _edy = new Edy (ofd.FileName);
        int estimatedWidth = _edy.EstimateWidth ();
        _widthUI.Maximum = _edy.Size;
        int width = (int) _widthUI.Value;
        if (estimatedWidth != -1) {
          width = estimatedWidth;
          _widthUI.Value = width;
        }
        _edy.CreateBitmap (width);
        _entropyUI.Value = (decimal) _edy.Entropy;
        _dsUI.Refresh ();
      }
    }

    private void _dsUI_Paint (object sender, PaintEventArgs e) {
      if (_edy != null) {
        e.Graphics.DrawImage (_edy.Bitmap, 0, 0);
      }
    }

    private void _widthUI_ValueChanged (object sender, EventArgs e) {
      _edy.CreateBitmap ((int) _widthUI.Value);
      _entropyUI.Value = (decimal) _edy.Entropy;
      _dsUI.Refresh ();
    }
  }
}